// main execution:
print("creating window");
window = new GtkWindow(GTK.WINDOW_TOPLEVEL);
window.set_title("Hello Buttons!");
window.connect("delete_event", delete_event );
window.border_width(70);

print("creating box")
box = new GtkVBox(false, 0);
window.add(box);
buttons = [];
for (var i = 1;  i < 5; i++)
{
buttons[i] = new GtkButton("Array Button " + i);
// below can use eval for more efficiency? than the function which returns a function.
//  I don't know other way to make that i become hard coded into the call, as opposed to a 
// reference to the number 11, comment out the last one to see that in action
// eval (' ( function () { button_clicked(' + i + ') } ) ')
buttons[i].connect("clicked", eval (' ( function () { button_clicked(' + i + ') } ) ') );
// buttons[i].connect("clicked", ( function (arg) { return function () { button_clicked(arg) } } (i) ) );
// buttons[i].connect("clicked", function () { button_clicked(i) } );
box.pack_start(buttons[i], true, true, 0);
buttons[i].show();
print("Array Button Made, #" + i);
}

text = new GtkEntry();
text.set_text("lil bit a text");
text.show();
box.pack_start(text, true,true, 0);

button = new GtkButton("Print Text to Stdout");
button.connect("clicked", function () { print(text.get_text()) } );
button.show();
box.pack_start(button, true,true, 0);

text_pool = new GtkEntry();
text_pool.set_text("PREPEND ME!");
text_pool.show();
box.pack_start(text_pool, true,true, 0);

h = new GtkHBox(false, 0);
h.show();
box.pack_start(h, true, true, 0);

button = new GtkButton("prepend");
button.connect("clicked", function () { text.prepend_text ( text_pool.get_text() );
	text_pool.set_text("APPEND ME NOW!");
 } );
button.show();
h.pack_start(button, true, true, 0);
button = new GtkButton("append");
button.connect("clicked", function () { text.append_text ( text_pool.get_text() );
	text_pool.set_text("PREPEND ME NOW!");
 } );
button.show();
h.pack_start(button, true, true, 0);

button = new GtkButton("set position");
button.connect("clicked", function () { text.set_position(parseInt(text_pool.get_text())); text.grab_focus() } );
button.show();
box.pack_start(button, true, true, 0);

button = new GtkButton("select region");
button.connect("clicked", function () { var a = text_pool.get_text().split(","); text.select_region(parseInt(a[0]), parseInt(a[1])) } );
button.show();
box.pack_start(button, true, true, 0);

/*
button = new GtkButton("resize list");
button.connect("clicked", function () { var  a=text_pool.get_text().split(","); sw.set_usize(parseInt(a[0]), parseInt(a[1])) } );
button.show();
box.pack_start(button, true, true, 0);
*/


hadj = new GtkAdjustment(1.0,1.0,1.0, 1.0,1.0,1.0);
print(GtkAdjustment);
vadj = new GtkAdjustment(50,10,10, 10,10,32);
texta = new GtkText(hadj, vadj);
texta.set_editable(true);
texta.show();
box.pack_start(texta, true, true, 0);

ta_button = new GtkButton("insert text")
ta_button.connect("clicked", function () { texta.insert_text( {type: 0, ascent: 14, descent: 5}, {pixel: 1, red: 255, green: 255, blue: 0}, {pixel:1, red: 0, green: 0, blue: 255}, "c h a r s") });
ta_button.show();
box.pack_start(ta_button, true, true, 0);

box.show();
window.show();
gtk_main();


// subs:
function button_clicked(data) {
  print("Hello again - " + data + " was pressed");
}

function delete_event() {
  print ("See ya!");
  gtk_main_quit();
}


