#include "js-gtk.h"

/* Horizontal separator */

JSGTK_CLASS(HSeparator);

JSBool hseparator_ctor(JSContext *cx, JSObject *obj,
		       uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *hseparator;
    
    hseparator = gtk_hseparator_new();
    JS_SetPrivate(cx, obj, hseparator);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(hseparator), obj);
    return JS_TRUE;
}

#define hseparator_methods NULL
JSGTK_INIT_FUNC(hseparator,HSeparator,0);

/* Vertical separator */

JSGTK_CLASS(VSeparator);

JSBool vseparator_ctor(JSContext *cx, JSObject *obj,
		       uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *vseparator;
    
    vseparator = gtk_vseparator_new();
    JS_SetPrivate(cx, obj, vseparator);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(vseparator), obj);
    return JS_TRUE;
}

#define vseparator_methods NULL
JSGTK_INIT_FUNC(vseparator,VSeparator,0);

/* Base separator */

JSGTK_CLASS(Separator);

JSBool jsgtkseparator_init(JSContext *cx, JSObject *global,
			   JSObject *gtkproto) {
    JSObject *separatorProto;
    
    separatorProto = JS_InitClass(cx, global, gtkproto, &jsgtk_SeparatorClass,
				  NULL, 0,
				  NULL, NULL,
				  NULL, NULL);
    if (!separatorProto ||
	!jsgtkhseparator_init(cx, global, separatorProto) ||
	!jsgtkhseparator_init(cx, global, separatorProto))
	return JS_FALSE;

    return JS_TRUE;
}
